Scala Reflection Library2.12.2-20170504-135222-21d12e9 < Back
 

# Packages

-  package root
  Definition Classes
    root
-  package scala
  Definition Classes
    root
-  package reflect
  Definition Classes
    scala
-  package api

  EXPERIMENTAL

  EXPERIMENTAL

  The Scala Reflection API (located in scala-reflect.jar).

  In Scala 2.10.0, the Scala Reflection API and its implementation have an "experimental" status. This means that the API and the docs are not complete and can be changed in binary- and source-incompatible manner in 2.10.1. This also means that the implementation has some known issues.

  The following types are the backbone of the Scala Reflection API, and serve as a good starting point for information about Scala Reflection:

  - scala.reflect.api.Symbols
  - scala.reflect.api.Types
  - scala.reflect.api.Mirrors
  - scala.reflect.api.Universe

  For more information about Scala Reflection, see the Reflection Guide

  Definition Classes
    reflect
- Annotations
- Constants
- Exprs
- FlagSets
- ImplicitTags
- Internals
- JavaUniverse
- Liftables
- Mirror
- Mirrors
- Names
- Position
- Positions
- Printers
- Quasiquotes
- Scopes
- StandardDefinitions
- StandardLiftables
- StandardNames
- Symbols
- TreeCreator
- Trees
- TypeCreator
- TypeTags
- Types
- Universe

t

scala.reflect.api

# FlagSets 

###

#### trait FlagSets extends AnyRef

EXPERIMENTAL

The trait that defines flag sets and operations on them.

`Flag`s are used to provide modifiers for abstract syntax trees that represent definitions via the `flags` field of scala.reflect.api.Trees#Modifiers. Trees that accept modifiers are:

- scala.reflect.api.Trees#ClassDef. Classes and traits.
- scala.reflect.api.Trees#ModuleDef. Objects.
- scala.reflect.api.Trees#ValDef. Vals, vars, parameters and self-type annotations.
- scala.reflect.api.Trees#DefDef. Methods and constructors.
- scala.reflect.api.Trees#TypeDef. Type aliases, abstract type members and type parameters.

For example, to create a class named `C` one would write something like:

    ClassDef(Modifiers(NoFlags), TypeName("C"), Nil, ...)

Here, the flag set is empty.

To make `C` private, one would write something like:

    ClassDef(Modifiers(PRIVATE), TypeName("C"), Nil, ...)

Flags can also be combined with the vertical bar operator (`|`). For example, a private final class is written something like:

    ClassDef(Modifiers(PRIVATE | FINAL), TypeName("C"), Nil, ...)

The list of all available flags is defined in scala.reflect.api.FlagSets#FlagValues, available via scala.reflect.api.FlagSets#Flag. (Typically one writes a wildcard import for this, e.g. `import scala.reflect.runtime.universe.Flag._`).

Definition trees are compiled down to symbols, so flags on modifiers of these trees are transformed into flags on the resulting symbols. Unlike trees, symbols don't expose flags, but rather provide `isXXX` test methods (e.g. `isFinal` can be used to test finality). These test methods might require an upcast with `asTerm`, `asType` or `asClass` as some flags only make sense for certain kinds of symbols.

Of Note: This part of the Reflection API is being considered as a candidate for redesign. It is quite possible that in future releases of the reflection API, flag sets could be replaced with something else.

For more details about `FlagSet`s and other aspects of Scala reflection, see the Reflection Guide

Self Type
  Universe
Source
  FlagSets.scala

Linear Supertypes
AnyRef, Any
Known Subclasses
JavaUniverse, Universe, Universe
Type Hierarchy
 
Ordering

1. Grouped
2. Alphabetic
3. By Inheritance

Inherited

1. FlagSets
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show All

Visibility

1. Public
2. All

### Type Members

1.  trait FlagOps extends Any

   The API of `FlagSet` instances.

   The API of `FlagSet` instances. The main source of information about flag sets is the scala.reflect.api.FlagSets page.

2.  abstract type FlagSet

   An abstract type representing sets of flags (like private, final, etc.) that apply to definition trees and symbols

3.  trait FlagValues extends AnyRef

   All possible values that can constitute flag sets.

   All possible values that can constitute flag sets. The main source of information about flag sets is the scala.reflect.api.FlagSets page.

### Abstract Value Members

1.  abstract val Flag: Universe.FlagValues

   A module that contains all possible values that can constitute flag sets.

2.  abstract val NoFlags: Universe.FlagSet

   The empty set of flags

3.  implicit abstract def addFlagOps(left: Universe.FlagSet): Universe.FlagOps

   The API of `FlagSet` instances.

### Concrete Value Members

1.  final def !=(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
2.  final def ##(): Int
   Definition Classes
     AnyRef → Any
3.  def +(other: String): String
   Implicit
     This member is added by an implicit conversion from FlagSets to any2stringadd[FlagSets] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd
4.  def ->[B](y: B): (FlagSets, B)
   Implicit
     This member is added by an implicit conversion from FlagSets to ArrowAssoc[FlagSets] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()
5.  final def ==(arg0: Any): Boolean
   Definition Classes
     AnyRef → Any
6.  final def asInstanceOf[T0]: T0
   Definition Classes
     Any
7.  def clone(): AnyRef
   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
8.  def ensuring(cond: (FlagSets) ⇒ Boolean, msg: ⇒ Any): FlagSets
   Implicit
     This member is added by an implicit conversion from FlagSets to Ensuring[FlagSets] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
9.  def ensuring(cond: (FlagSets) ⇒ Boolean): FlagSets
   Implicit
     This member is added by an implicit conversion from FlagSets to Ensuring[FlagSets] performed by method Ensuring in scala.Predef.
   Definition Classes
     Ensuring
10.  def ensuring(cond: Boolean, msg: ⇒ Any): FlagSets
    Implicit
      This member is added by an implicit conversion from FlagSets to Ensuring[FlagSets] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
11.  def ensuring(cond: Boolean): FlagSets
    Implicit
      This member is added by an implicit conversion from FlagSets to Ensuring[FlagSets] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring
12.  final def eq(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
13.  def equals(arg0: Any): Boolean
    Definition Classes
      AnyRef → Any
14.  def finalize(): Unit
    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
15.  def formatted(fmtstr: String): String
    Implicit
      This member is added by an implicit conversion from FlagSets to StringFormat[FlagSets] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()
16.  final def getClass(): Class[_]
    Definition Classes
      AnyRef → Any
17.  def hashCode(): Int
    Definition Classes
      AnyRef → Any
18.  final def isInstanceOf[T0]: Boolean
    Definition Classes
      Any
19.  final def ne(arg0: AnyRef): Boolean
    Definition Classes
      AnyRef
20.  final def notify(): Unit
    Definition Classes
      AnyRef
21.  final def notifyAll(): Unit
    Definition Classes
      AnyRef
22.  final def synchronized[T0](arg0: ⇒ T0): T0
    Definition Classes
      AnyRef
23.  def toString(): String
    Definition Classes
      AnyRef → Any
24.  final def wait(): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
25.  final def wait(arg0: Long, arg1: Int): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
26.  final def wait(arg0: Long): Unit
    Definition Classes
      AnyRef
    Annotations
      @throws( ... )
27.  def →[B](y: B): (FlagSets, B)
    Implicit
      This member is added by an implicit conversion from FlagSets to ArrowAssoc[FlagSets] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from FlagSets to any2stringadd[FlagSets]

### Inherited by implicit conversion StringFormat from FlagSets to StringFormat[FlagSets]

### Inherited by implicit conversion Ensuring from FlagSets to Ensuring[FlagSets]

### Inherited by implicit conversion ArrowAssoc from FlagSets to ArrowAssoc[FlagSets]

### Flags

### Ungrouped